Skip to main content Skip to footer

How to Add a JavaScript Excel XLSX Viewer to Your Web Application

Quick Start Guide
Tutorial Concept

Learn how to integrate a secure client-side Excel .XLSX viewer using a JavaScript spreadsheet component.

What You Will Need

NPM Packages:

Controls Referenced

SpreadJS - JavaScript Spreadsheet Component

Documentation | Demos

Many businesses rely on spreadsheets like Microsoft Excel to manage operations, making it essential to handle these files in modern JavaScript applications. SpreadJS, a JavaScript spreadsheet component, lets you load, view, edit, and save complex XLSX files in the browser. In this blog, we'll show you how to build an XLSX Viewer using SpreadJS, including importing Excel files and protecting sheets to control user edits.

Add Spreadsheets to Your JavaScript Enterprise Web Apps. Download SpreadJS Now!

How to Add an Excel XLSX Viewer to JavaScript Web Applications

  1. Create a JavaScript Spreadsheet Application
  2. Add Excel Import Code - Import Method
  3. Password Protect the JS Excel Viewer - Protect/Unprotect Methods

JavaScript Excel .xlsx Viewer Component

Download a Sample JavaScript Application to Follow Along with the Tutorial.


Create a JavaScript Spreadsheet Application 

Create a simple HTML file, including a DOM element for the JavaScript spreadsheet viewer and a side panel with options to choose from, and input an existing XLSX file. Then, set a password and protect or unprotect the worksheet.

<body>
<div style="display: flex; flex-direction: row; align-items: flex-start;">
    <!-- Spreadsheet Viewer -->
    <div id="spreadContainer" style="width: 925px; height: 600px;"></div>
    <!-- Side Panel -->
    <div id="sidebar" style="width: 275px; padding: 20px; background: #ddd; margin-left: 10px;">
        <p>Open Excel File (.xlsx):</p>
        <input type="file" id="fileInput" />
        <button id="openButton">Open Excel</button>
        <div style="margin-top: 20px;">
            <img id="protectStatus" src="data:image/png;base64...." alt="Protection Status" style="height: 25px;" />
            <p>Password:
            <input type="password" id="passwordInput" />
            </p>
            <button id="protectBtn">Protect</button>
            <button id="unprotectBtn">Unprotect</button>
        </div>
    </div>
</div>
</body>

Install the necessary JavaScript Spreadsheet Component NPM packages.

npm install @mescius/spread-sheets
npm install @mescius/spread-sheets-io
npm install @mescius/spread-sheets-charts
npm install @mescius/spread-sheets-shapes

Alternatively, download and install the associated SpreadJS release script files.

Be sure to add a reference to these packages in the HTML file.

<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <!-- SpreadJS CSS File -->
    <link rel="stylesheet" type="text/css" href="./node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
    <!-- SpreadJS JS Script Files-->
    <script src="./node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
    <script src="./node_modules/@mescius/spread-sheets-io/dist/gc.spread.sheets.io.min.js" type="text/javascript"></script>
    <script src="./node_modules/@mescius/spread-sheets-shapes/dist/gc.spread.sheets.shapes.min.js" type="text/javascript"></script>
    <script src="./node_modules/@mescius/spread-sheets-charts/dist/gc.spread.sheets.charts.min.js" type="text/javascript"></script>
    <!-- JS Spreadsheet Code file -->
    <script src="./app.js" type="text/javascript"></script>
</head>

Lastly, initialize the JavaScript XLSX viewer using the SpreadJS APIs Workbook constructor and passing the DOM element previously created by its ID.

window.onload = function () {
  // Initialize the JS XSLX viewer instance
  let spread = new GC.Spread.Sheets.Workbook(
    document.getElementById("spreadContainer"),
    { sheetCount: 2 }
);

The JavaScript application will now show the spreadsheet instance. Next, let's add some functionality to the side panel.

JavaScript Excel File Viewer Project

See our Quick Start Demo or Documentation for additional information on getting started with this JavaScript spreadsheet control.


Add Excel Import Code to a JavaScript Application

Depending on the application, you may want to allow end users to import an existing .xlsx file into the JavaScript Excel viewer application. To accomplish this, we will implement event listeners to capture a selected .xlsx file, and then invoke the JS spreadsheet API's import method on button click.

document.getElementById("openButton").addEventListener("click", openExcelFile);
let selectedFile = null;
// File input change
document.getElementById("fileInput").addEventListener("change", (e) => {
    selectedFile = e.target.files[0];
});
// Open the Excel file
function openExcelFile() {
    if (!selectedFile) return;
    const options = {fileType: GC.Spread.Sheets.FileType.excel,};
    spread.import(selectedFile,() => {console.log("Import successful");},
      (error) => {console.error("Import error:", error);},
      options
    );
  }

Notice the XLSX file can now be imported into the JS Excel Viewer application:

Open an .xlsx File in a JS Excel Viewer Control

See our Online Import/Export Demo Explorer or Documentation to learn more about the import and exporting capabilities of SpreadJS.


Password Protect the JavaScript Excel Viewer

Once the end user imports the file, they may want to protect the workbook using a password to prevent specific users from making changes. Using the JS spreadsheet API, developers can add this capability by invoking the Worksheet's protect and unprotect methods.

In this setProtectSheet() function, get the active worksheet, check to see if it is already protected, and if not, then invoke the protect method with a password if one is applied.

function protectSheet() {
    let sheet = spread.getActiveSheet();
    if (sheet.options.isProtected) { alert(alreadyProtect); return; }
    let password = document.getElementById("passwordInput").value;
    sheet.protect(password);
    document.getElementById("protectStatus").src = protectImg;
    document.getElementById("passwordInput").value = "";
  }

In this setUnprotectSheet() function, allow authorized users to unprotect a worksheet to make changes by providing a password and invoking the unprotect method.

function unprotectSheet() {
    let sheet = spread.getActiveSheet();
    let password = document.getElementById("passwordInput").value;
    if (sheet.hasPassword()) {
      let success = sheet.unprotect(password);
      if (!success) { alert(passwordWrongTip); return; }
    } else { sheet.unprotect(); }
    document.getElementById("protectStatus").src = unprotectImg;
    document.getElementById("passwordInput").value = "";
  }

Notice that users can now protect and unprotect the JavaScript spreadsheet using a set password.

Allow Users to Protect and Unprotect a JavaScript Excel Viewer Control

Check out the online Protect Worksheet Demo or the Documentation and learn more about the protection and cell locking/unlocking capabilities.

Looking for an Enterprise JavaScript Spreadsheet? Try SpreadJS Today!


JavaScript Spreadsheet Component 

This blog tutorial only scratches the surface of the full capabilities of the JavaScript spreadsheet component, SpreadJS. Check out our online demo explorer, documentation, blogs, and videos to see all the features and use cases SpreadJS can fulfill.

Looking for a different framework or platform? Explore the rest of our blog series to learn how to build Excel .xlsx Viewer apps across various environments:

Tags:

comments powered by Disqus

Skip to main content Skip to footer

How to Add a Vue Excel XLSX Viewer to Your Web Application

Quick Start Guide
Tutorial Concept Learn how to build a secure, interactive Excel (XLSX) viewer in Vue using a Vue spreadsheet component—covering integration, in-browser file rendering, and workbook protection for sensitive data.
What You Will Need

Vue.js Framework
NPM Packages:

  • @mescius/spread-sheets

  • @mescius/spread-sheets-vue.

  • @mescius/spread-sheets-io

Node.js (version 14 or later)
Code Editor – Visual Studio Code

Controls Referenced

SpreadJS - Vue Spreadsheet Component
Documentation | Online Demo Explorer

The industry leading Vue spreadsheet component, SpreadJS, is widely recognized for bringing Excel-like functionality to web applications, offering rich features and extensive customization options that make it ideal for interactive spreadsheet experiences. While the official SpreadJS documentation covers the basics of initializing workbooks and handling data, many developers need practical guidance for integrating these capabilities within modern frameworks like Vue.js.

In this blog post, we’ll explore how to build a Vue Excel XLSX Viewer using a Vue spreadsheet component. You’ll learn how to set up a Vue project, integrate the SpreadJS component, import Excel files directly in the browser, and apply sheet-level protection to secure your data.

Download a Trial of SpreadJS Today!

Steps to Create a Vue Excel XLSX Viewer Application

  1. Create Your Vue Project for an Excel XLSX Viewer
  2. Install SpreadJS Packages
  3. Import SpreadJS in Your Vue App
  4. Add the SpreadJS Component to Your Template
  5. Initializing the Spreadsheet
  6. Handle File Selection
  7. Load Excel Files
  8. Protect the Workbook
  9. Run Application

Download a finished sample application to follow along.


Create Your Vue Project for an Excel XLSX Viewer

Before integrating SpreadJS to create a powerful Vue Excel XLSX Viewer, you need a base Vue project. Vue.js provides a modern, reactive framework that makes building web applications fast and efficient. By combining Vue with SpreadJS, you can render Excel spreadsheets in the browser, enable data interaction, and even protect your workbooks.

Use the Vue CLI to quickly scaffold a new project. Open your terminal and run:

npm create vue@latest

During the setup process, the CLI will prompt you to configure your project. Here’s what you can select based on your requirements:

Creating a Vue Spreadsheet Application

After completing the prompts, Vue will scaffold the project structure in a folder with your chosen name.

Once the project is created, navigate to your project folder:

cd <your-project-name>
npm install

Then start the development server:

npm run dev

Open your browser at http://localhost:5173. You should see your Vue application running, ready for integrating SpreadJS to create your interactive Vue Excel XLSX viewer.

For guidance on getting started with Vue, please refer to our SpreadJS documentation ‘SpreadJS with Vue’.


Install SpreadJS Packages

SpreadJS provides a set of NPM packages for Vue that make integration smooth. To get started with creating your Vue Excel XLSX Viewer, you will need the following:

Command:

npm install @mescius/spread-sheets @mescius/spread-sheets-vue @mescius/spread-sheets-io

Import SpreadJS in Your Vue App

In this step, we set up SpreadJS in our Vue application by importing the necessary modules and styles into App.vue. By importing these modules at the start, we prepare our Vue app to render Excel spreadsheets.

import "@mescius/spread-sheets/styles/gc.spread.sheets.excel2016colorful.css";
import * as GC from "@mescius/spread-sheets";
import "@mescius/spread-sheets-vue";
import "@mescius/spread-sheets-io";

Add the SpreadJS Component to Your Template

To start building your Vue Excel XLSX Viewer, you need to add the <gc-spread-sheets> component to your Vue template. This component is the core of the SpreadJS library and allows you to render a fully interactive spreadsheet in the browser, just like Excel.

In the template below, we also create an options-container sidebar for file upload and worksheet protection controls:

<template>
  <div style="display: flex;">
    <!-- SpreadJS Excel Viewer Component -->
    <gc-spread-sheets class="spread-host" @workbookInitialized="initWorkbook"></gc-spread-sheets>
    <!-- Sidebar Controls for File Upload and Protection -->
    <div class="options-container">
      <p>Open Excel Files (.xlsx)</p>
      <input type="file" accept=".xlsx" @change="changeFileDemo" />
      <input type="button" value="Import" class="button" @click="loadExcel" />
      <p style="margin-top: 20px;">Worksheet Protection</p>
      <input type="button" value="Protect" class="button" @click="setProtectSheet" />
      <input type="button" value="Unprotect" class="button" @click="setUnprotectSheet" />
    </div>
  </div>
</template>

Initializing the Spreadsheet

In this step, we initialize the SpreadJS workbook once it’s fully loaded in our Vue app. The @workbookInitialized event from the <gc-spread-sheets> component triggers the initWorkbook function, giving us access to the SpreadJS workbook instance (spreadInstance).

Inside this function, we store the instance in a local variable and access the active worksheet using getActiveSheet(). Then, we set default text values in the first few cells to verify that our spreadsheet is working correctly.

function initWorkbook(spreadInstance) {
  spread = spreadInstance;

  const sheet = spread.getActiveSheet();

  sheet.setValue(0, 0, "Vue + SpreadJS Excel Viewer");
  sheet.setValue(1, 0, "Import an Excel file to view it below.");
}

The image below shows the Vue project running in the browser after setup. The default text appears in the first few cells, confirming that the SpreadJS workbook has been successfully initialized.

Add Excel Importing Capabilities to Vue Enterprise Applications

Refer to our Quick Start Demo or Documentation for further guidance on getting started.


Handle File Selection

In this step, we implement logic to capture the Excel file we choose. The changeFileDemo function listens for changes on the file input and stores the selected file in a variable. This allows the loadExcel function to access the file later for import.

function changeFileDemo(e) {
  selectedFile.value = e.target.files[0];
}

Load Excel Files

In this step, we handle loading the selected Excel file into the SpreadJS workbook. The loadExcel function ensures a file has been selected, checks its type (.xlsx), and uses the SpreadJS import method to load it into the spreadsheet.

function loadExcel() {
  if (!selectedFile.value) {
    alert("Please select a file first!");
    return;
  }
  const fileName = selectedFile.value.name.toLowerCase();
  const fileExt = fileName.split(".").pop();
  const fileType =
    fileExt === "xlsx"
      ? GC.Spread.Sheets.FileType.excel
      : null;
  if (!fileType) {
    alert("Unsupported file type!");
    return;
  }
  spread.import(
    selectedFile.value,
    () => {
      console.log("File Loaded Successfully");
      protectWorkbook();
    },
    (err) => {
      console.error("Import failed:", err);
      alert("Failed to import Excel file.");
    },
    { fileType }
  );
}

After selecting an Excel (.xlsx) file using the Choose File button, clicking Import will load the file into our Vue Excel XLSX Viewer. The workbook will be automatically protected upon import, preventing unwanted edits until you choose to unprotect it using the Unprotect button described below.

Protect Vue Spreadsheet Data - Creating an Excel Viewer Application


Workbook Protection

In this step, we implement protection for worksheets in the workbook. After an Excel file is loaded, we protect all sheets in the workbook to prevent unintended edits. Using sheet.options.protectionOptions, we allow cell selection but disable editing, inserting, deleting, resizing, sorting, and filtering. This ensures imported data is secure while remaining viewable.

For more detailed guidance on worksheet protection and password settings, you can refer to Protect Sheet with Password of official SpreadJS documentation. 

function protectWorkbook() {
  const sheetCount = spread.getSheetCount();
  for (let i = 0; i < sheetCount; i++) {
    const sheet = spread.getSheet(i);
    sheet.options.isProtected = true;
    sheet.options.protectionOptions = {
      allowSelectLockedCells: true,
      allowSelectUnlockedCells: true,
      allowSort: false,
      allowFilter: false,
      allowEditObjects: false,
      allowResizeRows: false,
      allowResizeColumns: false,
      allowInsertRows: false,
      allowDeleteRows: false,
      allowInsertColumns: false,
      allowDeleteColumns: false,
    };
    sheet.protect(password); 
  }
  console.log("All sheets are protected with custom options.");
  alert("Workbook imported and protected with password");
}

If you need to allow edits to a protected sheet, the Unprotect button calls setUnprotectSheet()

Allow End-User Password Input in JavaScript Spreadsheets to Edit Data

This function prompts the user for a password and removes protection from the active sheet if the password is correct.

For more detailed guidance on unprotection worksheet you can refer to Unprotect method of official SpreadJS documentation. 

function setUnprotectSheet() {
  const sheet = spread.getActiveSheet();
  if (!sheet.options.isProtected) {
    alert("Sheet is already unprotected!");
    return;
  }

  const userPassword = prompt("Enter the password to unprotect this sheet:");
  if (userPassword === null) return;

  const success = sheet.unprotect(userPassword);
  if (!success) {
    alert("Incorrect password!");
  } else {
    alert("Sheet unprotected successfully!");
  }
}

After unprotecting the active sheet and making the necessary changes, you can reapply protection to the same sheet using the setProtectSheet() function.

Protect Imported Excel Files Data Allowing Users to Only View the File

The setProtectSheet() function applies the same protection options to the currently active sheet, useful for selectively securing a sheet without affecting others.

function setProtectSheet() {
  const sheet = spread.getActiveSheet();
  if (sheet.options.isProtected) {
    alert("The worksheet is already protected!");
    return;
  }
  sheet.options.protectionOptions = {
    allowSelectLockedCells: true,
    allowSelectUnlockedCells: true,
    allowSort: false,
    allowFilter: false,
    allowEditObjects: false,
    allowResizeRows: false,
    allowResizeColumns: false,
    allowInsertRows: false,
    allowDeleteRows: false,
    allowInsertColumns: false,
    allowDeleteColumns: false,
  };
  sheet.protect(password);
  alert("Sheet protected with custom options!");
}

Run Your Application

In this final step, we start the Vue development server to see our Vue Excel XLSX Viewer in action. By running npm run dev, the app launches locally, allowing you to test importing Excel files, viewing them in the spreadsheet, and verifying that workbook protection is applied correctly.

Open http://localhost:5173 in your browser to interact with your fully functional Excel viewer built with Vue and SpreadJS.

Excel File Viewer in a Vue Application Example


Conclusion

With this setup on SpreadJS, users can import Excel files, explore their contents, and interact with spreadsheets directly in the browser. This approach provides a powerful, client-side solution for building responsive and feature-rich Excel viewers in Vue applications.

By following these steps, you now have a solid foundation to expand your viewer with additional features like custom formatting, formulas, filtering, and more. You can explore all these features by checking out our online demo explorer, documentation, blogs, and videos to see all the features and use cases SpreadJS can fulfill.

Tags:

comments powered by Disqus

Skip to main content Skip to footer

How to Add a React Excel XLSX Viewer to Your Web Application

Quick Start Guide
Tutorial Concept

Learn how to integrate a secure client-side Excel .XLSX viewer using a React spreadsheet component.

What You Will Need
Controls Referenced

SpreadJS - React Spreadsheet Component
Documentation | Demos

Many businesses rely on spreadsheets, especially Microsoft Excel, for managing operations. Therefore, it's crucial to access and manage these files within enterprise React applications. SpreadJS, a React spreadsheet component, allows users to load, edit, and save complex XLSX files across various frameworks. In this blog, we'll demonstrate how to add an XLSX Viewer to your React 18 web application using SpreadJS. This article will guide you through importing Excel files into a user-friendly interface and protecting the React worksheet to restrict user edits.

Add Spreadsheets to Your React Enterprise Web Apps. Download SpreadJS Now!

How to Add an Excel XLSX Viewer to React Web Applications:

  1. Create a React Spreadsheet Application
  2. Add Excel Import Code - Import Method
  3. Invoke the Protect and Unprotect Methods

Download the sample application to follow along with this blog.

React Excel Spreadsheet Viewer Component


Create a React Spreadsheet Application

First, create a React project by opening the Command Prompt window and then type the following commands:

npx create-react-app sjs-react-viewer
cd sjs-react-viewer
npm start

Install the necessary SpreadJS NPM modules in your project using the following command:

npm install @mescius/spread-sheets
npm install @mescius/spread-sheets-react
npm install @mescius/spread-sheets-io
npm install @mescius/spread-sheets-charts
npm install @mescius/spread-sheets-shapes

Import the SpreadJS CSS in your app's index.js file using the following code:

import '@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css';

At the beginning of your App.js file, import the required modules. These imports will enable access to the spreadsheet object of SpreadJS and add support for charts, shapes, and importing/exporting in the React spreadsheet instance.

import React, { Component } from "react";
import { SpreadSheets } from "@mescius/spread-sheets-react";
import * as GC from "@mescius/spread-sheets";
import "@mescius/spread-sheets-charts";
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-io";

Define some constants that will be used in the application:

const passwordWrongTip = "Password is not correct!";
const alreadyProtect = "The worksheet is already protected!";
const unprotectImg = "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAACXBIWXMAAAsTAAALEwEAmpwYAAAB0UlEQVR4nO2YzU7CQBDHNyae9A30qF6NNlFv7QzhqheukN1An4Mbnv14A70YwgERX0XiWRNBKl8eMDGuGWy0LopoS0tl/8kkZLMT/r+dmW1axrS0tAKTYRjziJgCgFNEvAKAR0Tsub9pLUV72DTKsqw9ALhGRDkqaA/tZdOifD4/h4j7PxlX4gURC5QbtX/2B/PeKERqnlrBPU1vi/QR8dCyrO1kMrlAYZrmDgAcAcCTWgkA2I3EPA2j2vMAcAMA69/lJBKJDQC4VWfCiGKw6UZRT36UeU/e5heVSLGw5V6LXhMHv8g9VuBPWNhCxJoCsDVuLs2EkltjYct9QL2bME1zcdxc2qsA9FjYUq/EsPN9SwOgrsD4yuVyy5zzIue8K4SQkwz+9h8lzvlqkOadSRsXwyBOJpNZ8g1AJx+2efEBcRYEQDdCgLZvgKjMCzc0gNAVELqFfGkmW8i2bXl5cS7bTkO2mnVZrZQHa7EBqFbKUj73PwWtxQag7TSGAGgtNgCtZn0I4OH+Lj4A1bi3kG3bA8NUiVgOsQgwmAYQugJSt9Cst1An7q+UpQgBir4B0un0mhCiGYF5J5vNrrAgRN9n6BNHSO3UoZMPzLyW1j/XK1zJDTLJ864hAAAAAElFTkSuQmCC";
const protectImg = "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAACXBIWXMAAAsTAAALEwEAmpwYAAAB10lEQVR4nO2Yz0rDQBDGB0Ev+gZ6VK+iAfWWzJRe9dL3qfVQlWwR/7yBXqT0JepD2Nar0h4s2ERq3YArW4LGrdZq0qSx+8FACDvw/XZmNmQBtLS0IpNhGLNElEPESyK6QcQnInL9Z/kuJ9fAJMqyrF1EbBCRGBZyjVwLk6J8Pj9DRAc/GVfilYiKMjdp//AH88EoJmpetoK/m8EW6RHRqWVZW9lsdl6GaZrbiHiGiC9qJRBxJxHzchjVnkfEO0Rc+y4nk8msI+K9OhNGEoMtTxR154eZD+RtfFGJHMQt/1gMmjj5Re65An8BcYuIagrA5qi5ciaU3BrELf8D9W7CNM2FUXPlWgXAhbilHolx54eWBiBdgdElDmGJMyhzBo7HQIwzOAOHM6j0jmAlOvM2tMdt3FNBbGiLEiyGBpA7H7d576MaV1EAOAkCPIYGSMq854cG8HQFQLdQKE1nCx3Pie71vnBbDeE266JbLfTfpQagWy0Ix3E+RR8iLQBuqzEA4LZuUwTQrA8CNGtpb6G9lA1xtdCvRCqH2IswQAMwXQGhW2iqW4jb0En1LyVnUEkQoBwaoMdglTN4iN28De3nEixDFJL3M/KKI4524jZ05M5HZl5L65/rDc6nQtkkwmMVAAAAAElFTkSuQmCC";

Update the component App, which initializes its state to manage a selected file, spreadsheet protection status, and password. It sets up inline styles for a spreadsheet container and prepares a placeholder for the spreadsheet reference.

class App extends Component {
  constructor(props) {
    super(props);
    this.hostStyle = {
      width: "950px",
      height: "600px",
    };
    this.spread = null;
    this.state = {
      selectedFile: null,
      protectSheet: false,
      password: "",
    };
  }
}

Update the render method to extract protectSheet and password from the state and organize the layout with a flex container. It includes a div for the SpreadJS react spreadsheets component, which initializes the workbook, a sidebar containing a file input, a button to open the selected file, an image indicating sheet protection status, a password input field, and buttons to protect or unprotect the sheet, with their disabled state based on protectSheet.

  render() {
    const { protectSheet, password } = this.state;
    return (
      <div style={{ display: "flex" }}>
        <div style={{ width: "950px", height: "600px" }}>
          <SpreadSheets
            workbookInitialized={(spread) => this.initSpread(spread)}
            hostStyle={this.hostStyle}
          ></SpreadSheets>
        </div>
        <div style={{ width: "15%", padding: "20px", background: "#ddd" }}>
          <p>Open Excel Files (.xlsx)</p>
          <input type="file" onChange={this.handleFileChange} />
          <button onClick={this.handleOpenExcel}>Open Excel</button>
          <br />
          <br />
          <img
            id="protectStatus"
            style={{ height: "25px" }}
            src={protectSheet ? protectImg : unprotectImg}
          />
          <p>
            Password:
            <input
              id="protectPassword"
              type="password"
              value={password}
              onChange={(e) => this.setState({ password: e.target.value })}
            />{" "}
          </p>
          <br />
          <input
            type="button"
            value="Protect"
            id="protectBtn"
            onClick={() => {
              this.setProtectSheet();
            }}
            style={{ width: "100px" }}
            disabled={protectSheet}
          />
          <input
            type="button"
            value="Unprotect"
            id="unprotectBtn"
            onClick={() => {
              this.setUnprotectSheet();
            }}
            style={{ width: "100px", marginLeft: "10px" }}
            disabled={!protectSheet}
          />
        </div>
      </div>
    );
  }

Users can modify the workbook when it is being initialized; in this case, we want two worksheets in the instance on page load.

initSpread(spread) {
    this.spread = spread;
    this.spread.setSheetCount(2);
  }

Create empty functions for all of the needed actions. We will add the code logic for each of these functions later in this blog.

  // Get the selected Excel file
  handleFileChange = (e) => {
  };
  // Open the instance as an Excel File
  handleOpenExcel = () => {
  };
  // Unprotect the worksheet
  setUnprotectSheet() {
  };
  // Protect the workshet
  setProtectSheet() {
  };

Save all the files, and run the React app:

npm start

You have now created a React Spreadsheet app.

Create a React Spreadsheet app - Import and Export .xlsx


Add Excel Import Code to the React App

Importing an Excel file into the React spreadsheet application requires us to handle the change and invoke the spreadsheets import method. The handleFileChange function will be used to capture the selected Excel file when it's changed and update the component's state with the selected file.

// Get the selected Excel file
  handleFileChange = (e) => {
    this.setState({
      selectedFile: e.target.files[0],
    });
  };

The handleOpenExcel function is triggered when the user clicks the "Open Excel" button. It first checks if a file is selected. If not, it returns early. If a file is selected, it constructs import options specifying the FileType as Excel. Then, it calls the import method of the SpreadJS instance (this.spread) with the selected file and import options.

  // Open the instance as an Excel File
  handleOpenExcel = () => {
    const file = this.state.selectedFile;
    if (!file) {
      return;
    }
    // Specify the file type to ensure proper import
    const options = {
      fileType: GC.Spread.Sheets.FileType.excel,
    };
    this.spread.import(
      file,
      () => {
        console.log("Import successful");
      },
      (e) => {
        console.error("Error during import:", e);
      },
      options
    );
  };

Alternatively, you can read an Excel file from a URL on a server. Read more in this blog.

Run the app, notice an Excel (.xlsx) file can now be imported, viewed, and modified in the React spreadsheet component.

Import and export from React Excel Viewer


Protect the React Spreadsheet

After successfully importing an Excel file into SpreadJS, users can easily interact with the spreadsheet data. Alternatively, you may find it necessary to restrict editing on the spreadsheet. To accomplish this, SpreadJS offers the Worksheet protect method

In the setProtectSheet() function, get the active worksheet, check to see if it is already protected, and if not, then invoke the protect method with a password if one is applied:

// Protect the worksheet
  setProtectSheet() {
    let sheet = this.spread.getActiveSheet();
    if (sheet.options.isProtected) {
      alert(alreadyProtect);
      return;
    }
    const password = this.state.password;
    sheet.protect(password);
    this.setState({
      protectSheet: true,
      password: "",
    });
  }

Allow authorized users to unprotect a worksheet to make changes by providing a password and invoking the worksheets unprotect method within the setUnprotectSheet() function.

// Unprotect the worksheet
  setUnprotectSheet() {
    const password = this.state.password;
    let sheet = this.spread.getActiveSheet();

    if (sheet.hasPassword()) {
      let success = sheet.unprotect(password);
      if (!success) {
        alert(passwordWrongTip);
        return;
      }
    } else {
      sheet.unprotect();
    }
    this.setState({
      protectSheet: false,
      password: "",
    });
  }

Run the sample app and notice users can now protect and unprotect the React spreadsheet using a password.

Protect and Unprotect Spreadsheet in a React Excel .xlsx Viewer Control


Learn More About React Spreadsheet Components

This article only scratches the surface of the full capabilities of SpreadJS, a React spreadsheet component. Review the documentation to see some of the many available features, and check out our online demos to see the features in action and interact with the sample code. Integrating a spreadsheet component into your applications allows you to customize your users' experience and provide them with familiar spreadsheet functionality without referring them to an external program. Check out our video to learn more:

Check out our other blog article in this series, where we demonstrate how to create Excel .xlsx Viewer applications in other frameworks:

Tags:

comments powered by Disqus